/* ============================================================
 *
 * This file is a part of digiKam project
 * http://www.digikam.org
 * 
 * Date        : 2004-07-09
 * Description : a tdeio-slave to process tag query on 
 *               digiKam albums.
 *
 * Copyright (C) 2004 by Renchi Raju <renchi@pooh.tam.uiuc.edu>
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * ============================================================ */

#ifndef DIGIKAMTAGS_H
#define DIGIKAMTAGS_H

// TQt includes.

#include <tqstring.h>

// KDE includes.

#include <tdeio/slavebase.h>

// Local includes.

#include "sqlitedb.h"

class KURL;
class TQCString;

class tdeio_digikamtagsProtocol : public TDEIO::SlaveBase
{
public:

    tdeio_digikamtagsProtocol(const TQCString &pool_socket,
                            const TQCString &app_socket);
    virtual ~tdeio_digikamtagsProtocol();

    void special(const TQByteArray& data);

private:

    SqliteDB           m_db;
    TQString            m_libraryPath;
};


#endif /* DIGIKAMTAGS_H */
